import os
import pygame
import sys
import math
import random

from pygame.locals import *

sys.path.insert(1, "lib")
from loader import *
from Config import *
from GameScreen import GameScreen
from FPSScreen import FPSScreen

class game:
	def __init__(self,surface,clock):
		self.loader = loader()
		self.loader.init_map()
		self.clock = clock
		self.alive = True
		self.screen = surface
		self.width = surface.get_size()[0]
		self.height = surface.get_size()[1]
		#pygame.mouse.set_visible(False)
		self.reset()
		
	def reset(self):
		self.screens = [ GameScreen(), FPSScreen(self.clock) ]
		self.active = 0
	
	def draw(self):
		for obj in self.screens:
			obj.draw(self.screen)
		
	def handle_event(self,event):
		self.alive = self.screens[ self.active ].handle_event(event)
		if event.type == QUIT:
			self.alive = False
		return self.alive
	
	def update(self):
		done = False
		for obj in self.screens:
			done = obj.update() or done
		return done