import pygame
import loader
import State
import os

class Button:
	def __init__(self,image,pos,on_click):
		self.on_click = on_click
		self.loader = loader.loader()
		self.surf = self.loader.load(os.path.join("res","art","buttons",image))
		self.size = self.surf[0].get_size()
		self.rect = pygame.Rect(pos[0],pos[1],self.size[0],self.size[1])
		self.index = 0
	
	def hover(self,coords):
		if self.rect.collidepoint(coords):
			self.index = 1
		else:
			self.index = 0
	
	def click(self,coords):
		if self.rect.collidepoint(coords):
			self.on_click()
	
	def draw(self,surf):
		surf.blit(self.surf[self.index],self.rect)