import pygame
import random
import loader
import os
from Config import *
from State import State

class CloudManager:
	def __init__(self,n):
		self.n = n
		self.state = State()
		self.clouds = []
		for i in range(0,self.n/2):
			self.clouds.append(Cloud(ScreenSize[0]))
	
	def update(self,x):
		todel = []
		for cloud in self.clouds:
			cloud.update()
			if cloud.pos[0]-x > ScreenSize[0]:
				todel.append(cloud)
		for cloud in todel:
			self.clouds.remove(cloud)
		for i in range(0,self.n-len(self.clouds)):
			self.clouds.append(Cloud(x))
			
	def draw(self,surf,x):
		if self.state.quality > 0:
			for cloud in self.clouds:
				cloud.draw(surf,x)
	
class Cloud:
	def __init__(self,x=0):
		load = loader.loader()
		self.surf = load.load(os.path.join("res","art","clouds"))
		self.surf_index = random.randint(0,len(self.surf)-1)
		self.pos = [x+random.randint(-ScreenSize[0],-self.surf[self.surf_index].get_size()[0]),random.randint(0,ScreenSize[1]/2)]
		self.speed = random.random()*3+1
	
	def update(self):
		self.pos[0] += self.speed
	
	def draw(self,surf,x):
		surf.blit(self.surf[self.surf_index],(self.pos[0]-x,self.pos[1]))