import pygame
import random
import loader
import os
from Config import *

import pymunk
import math
import pymunk._chipmunk as cp
from wall import Wall
from State import State

class Doom:
	def __init__(self,space,reset_func):
		self.loader = loader.loader()
		self.edge = self.loader.load(os.path.join("res","art","wall.png"))[0]
		self.x = -self.edge.get_size()[0]
		self.width = self.edge.get_size()[0]
		self.space = space
		self.state = State()
		self.wall = Wall(space,(self.x,0),(6,self.edge.get_size()[1]),(207,0))
		self.reset_func = reset_func
		
	def reset(self):
		self.x = -self.edge.get_size()[0]
		self.state.wall_speed = 0
	
	def update(self):
		if not self.state.in_victory:
			self.x += self.state.wall_speed
			self.wall.update_x(self.x)
			if self.x >= self.state.screensize[0]-25:
				self.reset_func()
		
	def draw(self,surf,x):
		if self.state.quality > 0:
			if self.x-x > 0:
				pygame.draw.rect(surf,(40,40,40),pygame.Rect(0,0,self.x-x,ScreenSize[1]-100))
			if self.x - x+self.width > 0:
				surf.blit(self.edge,(self.x-x,0))
		else:
			self.wall.draw(surf,x)