from Screen import *
import pygame
from pygame.locals import *
from Config import *
import loader
from State import State

FPSCounter = 10

class FPSScreen(Screen):
	def __init__(self,clock):
		load = loader.loader()
		self.font = load.load_font("slkscr",16)
		self.clock = clock
		self.render()
		self.tick = 0
		self.state = State()
	
	def render(self):
		self.fps = self.font.render(str(int(self.clock.get_fps()*100)/100.0),False,(255,255,255))
		self.size = self.fps.get_size()
		
	def update(self):
		if self.state.quality >= 0:
			self.tick += 1
			if self.tick > FPSCounter:
				self.tick = 0
				self.render()
	
	def draw(self,surface):
		if self.state.quality >= 0:
			surface.blit(self.fps,(ScreenSize[0]-self.size[0],ScreenSize[1] - self.size[1]))