import pygame
from pygame.locals import *
from Config import *
import loader
import random
from State import State

MSGCounter = 240

class HelpText():
	def __init__(self,managers):
		load = loader.loader()
		self.managers = managers
		self.font = load.load_font("slkscr",16)
		self.mtick = 0
		self.state = State()
		self.tip = True
		self.m_index = 0
		self.messages = ["Put the ball into the bucket","Place blocks to guide the ball","Press 'Space' to cut the rope","You have to cut the rope",self.state.levels.current_level()["label"],"Go","I'm releasing the wall o' hurry","Hurry."]
		self.update_message()
	
	def reset(self):
		self.messages = [self.state.levels.current_level()["label"],"Go","Hurry."]
		self.m_index=0
		self.tip = True
		self.mtick = 0
		self.update_message()
	
	def update_message(self):
		if self.tip:
			if self.m_index < len(self.messages):
				self.tip = self.font.render(self.messages[self.m_index],False,(64,64,64))
				# Do clever actions
				if self.messages[self.m_index] == "Hurry." and self.state.levels.current > 1:
					self.state.wall_speed = 1.5
				self.m_index += 1
			else:
				self.tip = False
		
	def update(self):
		self.mtick += 1
		if self.mtick > MSGCounter:
			self.mtick = 0
			self.update_message()
	
	def draw(self,surface):
		if self.tip:
			surface.blit(self.tip,(ScreenSize[0]/2-self.tip.get_size()[0]/2,ScreenSize[1]/2-self.tip.get_size()[1]/2))