import pygame
import random
import loader
import os
from State import State
from Config import *

class InfoManager:
	def __init__(self):
		self.loader = loader.loader()
		self.bg = pygame.transform.scale(self.loader.load(os.path.join("res","art","bottom_gradient.png"))[0],(ScreenSize[0],125))
		self.buttonsurf = self.loader.load(os.path.join("res","art","tiles"))
		self.buttons = []
		self.labels = ["Your everyday block. Stable. Inert. Boring",
						"A ramp, for rolling up",
						"A ramp, for rolling down",
						"Hitting this ramp will accelerate the ball to the right",
						"Hitting this ramp will accelerate the ball to the right and up",
						"Wide, flat, and boring",
						"A cardboard box. Good for stacking, but too flimsy to hold anything heavy.",
						"This is a pinball bouncer. Somehow, it hovers in the air.",
						"This hovering thingy sends the ball crashing to the earth",
						"If the ball touches this wide platform it won't go up again!",
						"This tiny hovering circle bounces the ball back up.",
						"Send the ball flying AWAY from the cup. Genius!"]
		self.font = self.loader.load_font("slkscr",16)
		self.txt = None
		self.state = State()
		x = 10
		i = 0
		y = 40
		for s in self.buttonsurf:
			if i != 2:
				s2 = pygame.transform.scale(s,(s.get_size()[0]/2,s.get_size()[1]/2))
				if x + s2.get_size()[0] > self.state.screensize[0]:
					x = 40
					y += 40
				self.bg.blit(s2,(x,y))
				self.buttons.append(pygame.Rect(x,y,s2.get_size()[0],s2.get_size()[1]))
				x += s2.get_size()[0]+20
			i += 1
		
	def update(self):
		self
	
	def hover(self,coords):
		i = 0
		coords = [coords[0],coords[1]-(ScreenSize[1]-125)]
		for rect in self.buttons:
			if rect.collidepoint(coords):
				self.txt = self.font.render(self.labels[i],False,(196,196,196))
				return True
			i += 1
		self.txt = None
	
	def click(self,coords):
		index = 0
		coords = [coords[0],coords[1]-(ScreenSize[1]-125)]
		for rect in self.buttons:
			if rect.collidepoint(coords):
				print index
				return (self.buttonsurf[index],index)
			index += 1
			if index == 2:
				index += 1
		return False
		
	def draw(self,surf):
		surf.blit(self.bg,(0,ScreenSize[1]-125))
		if self.txt:
			surf.blit(self.txt,(20,ScreenSize[1]-35))