import pygame

from Config import *

class Label:
	def __init__(self,string,font,color,coords):
		self.font = font
		mwidth = font.size("n")[0]
		if mwidth * len(string) > ScreenSize[0] or string.find("\n") > -1:
			chars = int(ScreenSize[0]/mwidth)
			if string.find("\n") > -1:
				pair = string.split("\n")
				str1 = pair[0]
				str2 = pair[1]
			else:
				str1 = string[:chars]
				str2 = string[chars:]
			surface1 = font.render(str1,True,color,(255,255,255))
			surface2 = font.render(str2,True,color,(255,255,255))
			w = surface1.get_size()[0]
			w2 = surface2.get_size()[0]
			if w2 > w:
				w = w2
			h = surface1.get_size()[1] + surface2.get_size()[1]
			self.surface = pygame.surface.Surface((w,h))
			self.surface.fill((255,255,255))
			self.surface.set_colorkey((255,255,255))
			self.surface.blit(surface1,(0,0))
			self.surface.blit(surface2,(0,surface1.get_size()[1]))
		else:
			self.surface = font.render(string,True,color,(255,255,255))
		size = self.surface.get_size()
		self.width = size[0]
		self.height = size[1]
		self.coords = coords
		self.alpha = 0
		self.surface.set_alpha(self.alpha)
		self.goal_alpha = 128
		
	def set_y(self,y):
		self.coords = (self.coords[0],y)
		
	def draw(self,surf):
		if self.is_visible():
			surf.blit(self.surface,self.coords)
		
	def update(self):
		a = self.alpha
		if self.goal_alpha < self.alpha:
			self.alpha -= 15
			if self.alpha < self.goal_alpha:
				self.alpha = self.goal_alpha
		elif self.goal_alpha > self.alpha:
			self.alpha += 15
			if self.alpha > self.goal_alpha:
				self.alpha = self.goal_alpha
		if a != self.alpha:
			self.surface.set_alpha(self.alpha)
			
	def fade(self,alpha = 0):
		self.goal_alpha = alpha
		
	def is_visible(self):
		return (self.alpha > 0)