import os
import random
import pygame
import pymunk
from State import State

class LevelManager:
	def __init__(self,map):
		self.map = map
		self.state = State()
		
		self.levels = []
		self.levels.append( {"label":"Level 1: Just pull the trigger"} )
		self.levels.append( {"label":"Level 2: Clear Skies"} )
		self.levels.append( {"label":"Level 3: Watch for falling rocks"} )
		self.levels.append( {"label":"Level 4: Going Down"} )
		self.levels.append( {"label":"Level 5: \"Lift! We need Lift!\""} )
		self.levels.append( {"label":"Level 6: Pinball Wizard"} )
		self.levels.append( {"label":"Level 7: Elevate Me"} )
		self.levels.append( {"label":"Level 8: Right wing manifesto"} )
		self.levels.append( {"label":"Level 9: Stackers"} )
		self.levels.append( {"label":"Level 10: Party time!"} )
		self.levels.append( {"label":"Level 11: A Royale with Cheese"} )
		self.levels.append( {"label":"Level 12: All the close family"} )
		self.levels.append( {"label":"Level 13: Landing zone for a UFO"} )
		self.levels.append( {"label":"Level 14: Cutting Edge"} )
		self.levels.append( {"label":"Level 15: Reverse Cutting Edge"} )
		self.levels.append( {"label":"Level 16: Skateboarding is a crime"} )
		self.levels.append( {"label":"Level 17: Flying, however, is not"} )
		self.levels.append( {"label":"Level 18: \"Reverse, Jim! Reverse\""} )
		self.current = 0
		
	def current_level(self):
		return self.levels[self.current]
	
	def setup_current_level(self):
		level = self.current
		if level == 0:
			self.map.spawn(5,(95,626))
			#self.map.spawn(8,(815,361))
		elif level == 1:
			self # do nothing
		elif level == 2:
			for i in range(0,5):
				self.map.spawn(0,(random.randint(100,self.state.screensize[0]-200),self.state.screensize[1]-random.randint(200,400)))
		elif level == 3:
			self.map.spawn(0,(self.state.screensize[0]/2,self.state.screensize[1]-200))
			x = self.state.screensize[0]/5
			y = (self.state.screensize[1]-100)/4
			self.map.spawn(9,(x,y*3))
			self.map.spawn(9,(x*2,y))
			self.map.spawn(9,(x*3,y*2))
		elif level == 4:
			self.map.spawn(10,(200,self.state.screensize[1]-200))
			self.map.spawn(10,(600,self.state.screensize[1]-200))
		elif level == 5:
			self.map.spawn(0,(self.state.screensize[0]/2,self.state.screensize[1]-200))
			x = self.state.screensize[0]/5
			y = (self.state.screensize[1]-100)/4
			b = self.state.screensize[1]-100
			self.map.spawn(8,(x,b-y))
			self.map.spawn(8,(x*2,b-y*2))
			self.map.spawn(8,(x*3,b-y*3))
			self.map.spawn(8,(x*4,b-y*2))
		elif level == 6:
			self.map.spawn(0,(self.state.screensize[0]/2,self.state.screensize[1]-200))
			x = self.state.screensize[0]/12
			y = self.state.screensize[1] - (self.state.screensize[1]-100)/4
			for i in range(0,8):
				self.map.spawn(11,(150+x*i,y-i*10))
		elif level == 7:
			x = 70
			for i in range(0,6):
				x += self.map.spawn(i % 2+4,(x,self.state.screensize[1]-200))[0] + 20
		elif level == 8:
			y = self.state.screensize[1]-200
			self.map.spawn(6,(self.state.screensize[0]/2,y+50))
			for i in range(0,10):
				y -= self.map.spawn(7,(self.state.screensize[0]/2+random.randint(-1,1),y))[1] + 10
		elif level == 9:
			x = self.state.screensize[0]/12
			y = 300
			for i in range(0,15):
				self.map.spawn(8,(10+x*i,y-i*10))
			for i in range(0,10):
				self.map.spawn(2,(self.state.screensize[0]/2+random.randint(-300,300),random.randint(50,200)))
		elif level == 10:
			y = self.state.screensize[1]-200
			for i in range(0,10):
				y -= self.map.spawn(0,(self.state.screensize[0]/3+random.randint(-1,1),y))[1] + 10
				y -= self.map.spawn(0,(self.state.screensize[0]/3*2+random.randint(-1,1),y))[1] + 10
		elif level == 11:
			for i in range(0,10):
				self.map.spawn(2,(self.state.screensize[0]/2+random.randint(-300,300),random.randint(50,200)))
		elif level == 12:
			x = 200
			for i in [1,0,0,0,3]:
				x += self.map.spawn(i,(x,self.state.screensize[1]-150))[0]
			x = 325
			for i in [1,0,3]:
				x += self.map.spawn(i,(x,self.state.screensize[1]-210))[0]
			self.map.spawn(7,(275+(x-325)/2,self.state.screensize[1]-400))
		elif level == 13:
			x = 100
			while x < self.state.screensize[0]-200:
				x += self.map.spawn(4,(x,self.state.screensize[1]-150))[0]
		elif level == 14:
			x = 100
			while x < self.state.screensize[0]-200:
				x += self.map.spawn(5,(x,self.state.screensize[1]-150))[0]
		elif level == 15:
			x = 200
			for i in [1,0,0,0,0]:
				x += self.map.spawn(i,(x,self.state.screensize[1]-150))[0]
			x = 327
			for i in [1,0,0,0]:
				x += self.map.spawn(i,(x,self.state.screensize[1]-210))[0]
			x = 456
			for i in [1,0,0]:
				x += self.map.spawn(i,(x,self.state.screensize[1]-270))[0]
			x = 586
			for i in [1,0]:
				x += self.map.spawn(i,(x,self.state.screensize[1]-330))[0]
			x = 714
			for i in [1]:
				x += self.map.spawn(i,(x,self.state.screensize[1]-390))[0]
		elif level == 16:
			x = 200
			for i in [5,0,0,0,0]:
				x += self.map.spawn(i,(x,self.state.screensize[1]-150))[0]
			x = 327
			for i in [5,0,0,0]:
				x += self.map.spawn(i,(x,self.state.screensize[1]-210))[0]
			x = 456
			for i in [5,0,0]:
				x += self.map.spawn(i,(x,self.state.screensize[1]-270))[0]
			x = 586
			for i in [5,0]:
				x += self.map.spawn(i,(x,self.state.screensize[1]-330))[0]
			x = 714
			for i in [5]:
				x += self.map.spawn(i,(x,self.state.screensize[1]-390))[0]
		elif level == 17:
			x = self.state.screensize[0]-50
			y = 40
			for i in range(0,12):
				self.map.spawn(12,(x,y+i*40))
			x = self.state.screensize[0]-50
			y = 400
			for i in range(0,8):
				self.map.spawn(12,(x/2,y+i*40))
	
	def next_level(self):
		self.current += 1
		if self.current >= len(self.levels):
			self.current = 0