import pygame
import os
import random

class Looper:
    def __init__(self,clock):
        self.available = False
        if pygame.mixer.get_init():
            self.available = True
            self.load()
        self.clock = clock
    
    def load(self):
        self.sounds = []
        self.sounds.append( pygame.mixer.Sound(os.path.join("res","music","block1.aif")) )
        self.sounds.append( pygame.mixer.Sound(os.path.join("res","music","block2.aif")) )
        self.sounds.append( pygame.mixer.Sound(os.path.join("res","music","block3.aif")) )
        self.sounds.append( pygame.mixer.Sound(os.path.join("res","music","block4.aif")) )
        for snd in self.sounds:
            snd.set_volume(0.5)
        
    def start(self):
        self.current = self.sounds[random.randint(0,len(self.sounds)-1)]
        loops = random.randint(1,4)
        self.current.play(loops-1,0,1000)
        self.renew_at = pygame.time.get_ticks() + (loops * self.current.get_length() * 1000)-100
        
    def renew(self):
        self.current = self.sounds[random.randint(0,len(self.sounds)-1)]
        loops = random.randint(1,4)
        self.current.play(loops-1)
        self.renew_at = pygame.time.get_ticks() + (loops * self.current.get_length()*1000)-100
        
    def stop(self):
        pygame.mixer.fadeout(100)
        
    def update(self):
        if not self.available:
            return
        #print "check: ",pygame.time.get_ticks(),self.renew_at
        if pygame.time.get_ticks() >= self.renew_at:
            self.renew()