import pygame
import random
import loader
import os
from Config import *

import pymunk
import math
import pymunk._chipmunk as cp

from wall import Wall
from Block import Block
from Bucket import Bucket
from State import State
from constants import *

class MapManager:
	def __init__(self,space):
		self.state = State()
		self.space = space
		self.walls = []
		self.walls.append(Wall(space,(-30,0),(0,0),(0,ScreenSize[1]),BACKBOUNCEWALL))
		self.objects = []
		self.spawn_y = ScreenSize[1]-250
		x = ScreenSize[0]
		self.walls.append(Wall(space,(0,ScreenSize[1]-100),(-30,0),(x,0)))
		self.walls.append(Wall(space,(-30,0),(0,0),(x,0)))
		self.walls.append(Wall(space,(x,0),(0,0),(0,ScreenSize[1]),BOUNCEWALL))
		self.width = x
		self.statics = []
		self.no_draw = []
		self.count = 0
			
	def spawn(self,index,pos,y=None):
		self.count += 1
		print self.count
		if y:
			pos = [pos,y]
		print pos
		block = Block(self.space,index,pos[0],pos[1])
		self.objects.append( block )
		if block.anchor:
			self.statics.append( block.anchor )
		for child in block.children:
			self.no_draw.append( child )
		return block.size
		
	def empty(self):
		self.count = 0
		to_del = []
		for obj in self.objects:
			self.space.remove(obj.shape.body,obj.shape)
			to_del.append(obj)
		for obj in to_del:
			self.objects.remove(obj)
			
		to_del = []
		for obj in self.statics:
			self.space.remove_static(obj)
			to_del.append(obj)
		for obj in to_del:
			self.statics.remove(obj)
			
		to_del = []
		for obj in self.no_draw:
			try:
				self.space.remove(obj)
			except KeyError:
				print "Can't remove "+str(obj)
			to_del.append(obj)
		for obj in to_del:
			self.no_draw.remove(obj)
		
	def update(self):
		to_del = []
		for obj in self.objects:
			if not obj.update():
				to_del.append(obj)
		for obj in to_del:
			self.objects.remove(obj)
			self.space.remove(obj.shape.body,obj.shape)
		
	def draw(self,surf,x):
		if self.state.quality < 1:
			for wall in self.walls:
				wall.draw(surf,x)
		for obj in self.objects:
			obj.draw(surf,x)