import pygame
import random
from Config import *
from constants import *

import pymunk
import math
import pymunk._chipmunk as cp
from pymunk import Vec2d

from Block import Block
from Bucket import Bucket

class Player:
	def __init__(self,space,width):
		self.space = space
		self.player = None
		self.bucket = Bucket(space,(width-165,500))
		
	def position(self):
		return self.player.shape.body.position
			
	def spawn(self,pos):
		self.kill()
		self.player = Block(self.space,2,pos[0],pos[1]) # '2' is ball index
	
	def kill(self):
		if self.player:
			self.space.remove(self.player.shape.body,self.player.shape)
			self.player = None
		
	def update(self):
		if self.player:
			pos = self.player.shape.body.position
			if self.player.shape.body.position[1] > ScreenSize[1]:
				self.space.remove(self.player.shape.body,self.player.shape)
				self.spawn((pos[0],100))
			return True
	
	def go(self,dir):
		if not self.player:
			return False
		if dir == 0: # Left
			self.player.shape.body.apply_impulse(Vec2d(-1,0),Vec2d(0,0))
		elif dir == 1: # Right
			self.player.shape.body.apply_impulse(Vec2d(1,0),Vec2d(0,0))
		elif dir == 2: # Up
			self.player.shape.body.apply_impulse(Vec2d(0,-1),Vec2d(0,0))
		elif dir == 3: # Down
			self.player.shape.body.apply_impulse(Vec2d(0,1),Vec2d(0,0))
		
	def draw(self,surf,x):
		self.bucket.draw_bg(surf,x)
		if self.player:
			self.player.draw(surf,x)
		self.bucket.draw_fg(surf,x)