import pygame
import os
import loader
import random
from time import time

class SoundManager:
	def __init__(self):
		pygame.mixer.init
		self.sounds = {}
		self.music = []
		# load wavs
		for name in ["ricochet1","ricochet2","ricochet3","ricochet4"]:
			self.sounds[name] = pygame.mixer.Sound(os.path.join("res","audio",name+".wav"))
		# load oggs
		for name in ["victory"]:
			self.sounds[name] = pygame.mixer.Sound(os.path.join("res","audio",name+".ogg"))
		# load music
		for name in ["light background","dark background"]:
			snd = pygame.mixer.Sound(os.path.join("res","audio",name+".ogg"))
			snd.set_volume(0.5)
			self.music.append(snd)
		self.playing = None
		self.tick = 0
		self.stop_at = 0
	
	def play(self,name):
		self.sounds[name].play()
	
	def update(self):
		self.tick += 1
		if self.tick > 60:
			print str(time()) + " > " + str(self.stop_at)
			self.tick = 0
			if not self.playing or time() > self.stop_at:
				self.playing = self.music[random.randint(0,len(self.music)-1)]
				self.playing.play()
				self.stop_at = time() + self.playing.get_length() + 1