import pygame
from State import State
import loader
import os

class VictoryScreen:
	def __init__(self):
		self.loader = loader.loader()
		self.state = State()
		self.orig = self.loader.load(os.path.join("res","art","victory_screen.png"))[0]
		self.size = self.orig.get_size()
		self.coords = (self.state.screensize[0]/2-self.size[0]/2,self.state.screensize[1]/2-self.size[1]/2)
		self.render()
	
	def render(self):
		grey = (64,64,64)
		black = (0,0,0)
		self.bg = pygame.Surface(self.orig.get_size())
		self.bg.set_colorkey(black)
		self.large_font = self.loader.load_font("slkscr",48)
		self.med_font = self.loader.load_font("slkscr",32)
		# title
		title = self.large_font.render("Completed!",False,grey)
		self.bg.blit(title,(self.size[0]/2-title.get_size()[0]/2,10))
		# in...
		txt = self.med_font.render("in",False,grey)
		self.bg.blit(txt,(100,90))
		txt2 = self.large_font.render(str(self.state.reset_count),False,grey)
		self.bg.blit(txt2,(100+txt.get_size()[0]+5,80))
		tries = "tries"
		if self.state.reset_count == 1:
			tries = "try"
		txt3 = self.med_font.render(tries,False,grey)
		self.bg.blit(txt3,(100+txt.get_size()[0]+5+txt2.get_size()[0]+5,90))
		# with...
		txt = self.med_font.render("with",False,grey)
		self.bg.blit(txt,(80,160))
		txt2 = self.large_font.render(str(self.state.map.count),False,grey)
		self.bg.blit(txt2,(80+txt.get_size()[0]+5,150))
		s = "s"
		if self.state.map.count == 1:
			s = ""
		txt3 = self.med_font.render("block"+s,False,grey)
		self.bg.blit(txt3,(80+txt.get_size()[0]+5+txt2.get_size()[0]+5,160))
		# continue
		txt = self.med_font.render("Click to continue",False,grey)
		self.bg.blit(txt,(self.size[0]/2-txt.get_size()[0]/2,self.size[1]-txt.get_size()[1]-16))
	
	def draw(self,surf):
		surf.blit(self.orig,self.coords)
		surf.blit(self.bg,self.coords)