# For handling filenames... 
import os
import pygame
import random
import sys

from pygame.locals import *
from game import *
from loader import *
from Config import *

opts = 0
if DoubleBuffer:
	opts = opts | pygame.DOUBLEBUF
if Fullscreen:
	opts = opts | pygame.FULLSCREEN
screen = pygame.display.set_mode(ScreenSize,opts)

pygame.display.set_caption("Put the Ball in the Basket")

pygame.init()

def main(): 
	state = 0
	alive = True
	clock = pygame.time.Clock()
	app = game(screen,clock)
	while alive:
		# Events
		if pygame.event.peek(QUIT):
			alive = False
		events = pygame.event.get()
		
		if state == 0:
			for event in events:
				app.handle_event(event)
			update = app.update()
			app.draw()
			alive = app.alive
		if update:
			pygame.display.flip()
		clock.tick(Framerate)

if __name__ == '__main__':
	main()

